import splat.gen
import splat.filters
import splat

class ResampleGenerator(splat.gen.Generator):

    def __init__(self, samples, *args, **kw):
        super(ResampleGenerator, self).__init__(*args, **kw)
        self._samples = samples

    def _run(self, frag, levels, origin, freq, *args, **kw):
        delta = 0
        sample = None
        for f, s in self._samples.iteritems():
            new_delta = abs(f - freq)
            if delta == 0 or new_delta < delta:
                delta = new_delta
                sample = s
        ratio = f / freq
        tmp = sample.dup()
        smooth = 0.001
        tmprev = tmp.dup()
        splat.filters.reverse(tmprev)
        tmp.mix(tmprev, offset=tmp.duration)
        splat.filters.linear_fade(tmp, smooth)
        len0 = frag.duration / ratio
        while tmp.duration < len0:
            tmp2 = tmp.dup()
            tmp.mix(tmp2, offset=tmp.duration-smooth)
        tmp.resample(ratio=ratio, rate=48000)
        tmp.resize(frag.duration)
        frag.mix(tmp, offset=origin, levels=levels)
